#include <event.h>
#include <agenda.h>
#include <exception.h>
#include <taskTree.h>

// Since all the list functions are template functions, need to include
// the CC file here, so the right template functions can be generated.
#include "tcmList.cc"

template class tcmHandle<Task_Tree_Node>;
template class tcmHandle<_Action>;
template class tcmHandle<Ref_Count>;

template class tcmList<Event>;
template class tcmList<State_Event>;
template class tcmList<Task_Tree_Ref>;

template class List_Element<Event>;
//template void _handleItem(List_Element<Event> *);
tcmList<Event> tcmList<Event>::_freeList;
Event tcmList<Event>::nullItem;
template class Const_List_Iterate<Event>;
template class List_Iterate<Event>;

template class List_Element<State_Event>;
//template void _handleItem(List_Element<State_Event> *);
tcmList<State_Event> tcmList<State_Event>::_freeList;
State_Event tcmList<State_Event>::nullItem;
template class Const_List_Iterate<State_Event>;
template class List_Iterate<State_Event>;

template class List_Element<Task_Tree_Ref>;
//template void _handleItem(List_Element<Task_Tree_Ref> *);
tcmList<Task_Tree_Ref> tcmList<Task_Tree_Ref>::_freeList;
Task_Tree_Ref tcmList<Task_Tree_Ref>::nullItem;
template class List_Iterate<Task_Tree_Ref>;
template class Const_List_Iterate<Task_Tree_Ref>;
template Task_Tree_Ref makeHandle(Task_Tree_Node *);

template class tcmList<Pending_Event>;
template class List_Element<Pending_Event>;
//template void _handleItem(List_Element<Pending_Event> *);
tcmList<Pending_Event> tcmList<Pending_Event>::_freeList;
Pending_Event tcmList<Pending_Event>::nullItem;
template class queue<Pending_Event>;

template class queue<Task_Tree_Ref>;

template class List_Element<Timed_Event>;
template class Const_List_Iterate<Timed_Event>;
template class List_Iterate<Timed_Event>;
template class tcmList<Timed_Event>;
//template void _handleItem(List_Element<Timed_Event> *);
tcmList<Timed_Event> tcmList<Timed_Event>::_freeList;
Timed_Event tcmList<Timed_Event>::nullItem;
template class queue<Timed_Event>;
template class priority_queue<Timed_Event, Timed_Event_Comp>;

template class List_Element<External_Event>;
template class tcmList<External_Event>;
//template void _handleItem(List_Element<External_Event> *);
tcmList<External_Event> tcmList<External_Event>::_freeList;
External_Event tcmList<External_Event>::nullItem;
template class Const_List_Iterate<External_Event>;

template class tcmHandle<Exception_Handler>;
template class List_Element<Exception_Handler_Ref>;
//template void _handleItem(List_Element<Exception_Handler_Ref> *);
tcmList<Exception_Handler_Ref> tcmList<Exception_Handler_Ref>::_freeList;
Exception_Handler_Ref tcmList<Exception_Handler_Ref>::nullItem;
template class tcmList<Exception_Handler_Ref>;
template class List_Iterate<Exception_Handler_Ref>;
template class Const_List_Iterate<Exception_Handler_Ref>;
