
/*
 * This represents an arbitrary C/C++ Expression.
 */

public class DataExpression extends DataComponent
{
	/* Class variables */
  public final static String   FIRST_TOKEN_INDEX = "First";

	/* Instance Variables */

	/* Instance Methods */
  public DataExpression()
  {
  }

	/* Convenience method. */
  public DataExpression( String theString )
  {
    addSubcomponent ( theString );
  }


  public void generate ( DataDestination  theOutputDestination,
			 int              theObjectSubsetToGenerate )
  {
       	/* Print a warning if necessary... */
    warnIfInvalidObjectSubset ( theObjectSubsetToGenerate, "generate" );

    initializeGenerateSubcomponentIndex();
    generateAllRemainingSubcomponents ( theOutputDestination,
					theObjectSubsetToGenerate, false );
  }

}
